<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: io/readkrn.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_7dc76e12c3f74bb85b7effb3b7dc07e4.html">io</a>
  </div>
</div>
<div class="contents">
<h1>readkrn.c</h1><a href="readkrn_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: readkrn.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="magpario_8h.html">magpario.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;string.h&gt;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;ctype.h&gt;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a><a class="code" href="readkrn_8c.html#a85c6fd604f4655acf9edea63969a5676">00032</a> <span class="keywordtype">int</span> <a class="code" href="magpario_8h.html#a85c6fd604f4655acf9edea63969a5676">read_one_line</a>(FILE *fd, <span class="keywordtype">char</span> *line, <span class="keywordtype">int</span> bufsize, <span class="keywordtype">char</span> **comment_out)
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034   <span class="keywordtype">char</span> *comment, *temp;
<a name="l00035"></a>00035   <span class="keywordtype">int</span> len, blank;
<a name="l00036"></a>00036 
<a name="l00037"></a>00037   <span class="keywordflow">do</span> {
<a name="l00038"></a>00038     <span class="keywordflow">if</span> (fgets(line, bufsize, fd) == NULL) {
<a name="l00039"></a>00039       line[0]=0; <span class="comment">/* valid but empty */</span>
<a name="l00040"></a>00040       <span class="keywordflow">return</span>(-1);
<a name="l00041"></a>00041     }
<a name="l00042"></a>00042 
<a name="l00043"></a>00043     <span class="comment">/* check that it&#39;s not too long */</span>
<a name="l00044"></a>00044     len = strlen(line);
<a name="l00045"></a>00045     <span class="keywordflow">if</span> (len==bufsize-1 &amp;&amp; !(line[bufsize-1]==<span class="charliteral">&#39;\n&#39;</span> || feof(fd))) {
<a name="l00046"></a>00046       <span class="comment">/* line can&#39;t fit in 256-byte buffer */</span>
<a name="l00047"></a>00047       <span class="keywordflow">return</span>(-1);
<a name="l00048"></a>00048     }
<a name="l00049"></a>00049 
<a name="l00050"></a>00050     <span class="comment">/* chop end-of-line \r\n or \n */</span>
<a name="l00051"></a>00051     <span class="keywordflow">if</span> (len &gt;= 2 &amp;&amp; line[len-2]==<span class="charliteral">&#39;\r&#39;</span> &amp;&amp; line[len-1]==<span class="charliteral">&#39;\n&#39;</span>) {
<a name="l00052"></a>00052       line[len-2] = 0;
<a name="l00053"></a>00053     } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (len &gt;= 1 &amp;&amp; line[len-1]==<span class="charliteral">&#39;\n&#39;</span>) {
<a name="l00054"></a>00054       line[len-1] = 0;
<a name="l00055"></a>00055     }
<a name="l00056"></a>00056 
<a name="l00057"></a>00057     <span class="comment">/* split comments */</span>
<a name="l00058"></a>00058     comment=strchr(line, <span class="charliteral">&#39;#&#39;</span>);
<a name="l00059"></a>00059     <span class="keywordflow">if</span> (comment != NULL) {
<a name="l00060"></a>00060       *comment=0;
<a name="l00061"></a>00061       comment++;
<a name="l00062"></a>00062     }
<a name="l00063"></a>00063 
<a name="l00064"></a>00064     <span class="comment">/* skip blank lines (all space) */</span>
<a name="l00065"></a>00065     <span class="keywordflow">for</span> (temp=line; *temp &amp;&amp; isspace(*temp); temp++) {}
<a name="l00066"></a>00066     <span class="keywordflow">if</span> (*temp) { blank=0; } <span class="keywordflow">else</span> { blank = 1; }
<a name="l00067"></a>00067   } <span class="keywordflow">while</span> (blank);
<a name="l00068"></a>00068 
<a name="l00069"></a>00069   <span class="keywordflow">if</span> (comment_out) *comment_out = comment;
<a name="l00070"></a>00070   <span class="keywordflow">return</span>(1);
<a name="l00071"></a>00071 }
<a name="l00072"></a>00072 
<a name="l00073"></a><a class="code" href="readkrn_8c.html#a59544353738dfce0bdce48409d9b3c8b">00073</a> <span class="keywordtype">int</span> <a class="code" href="magpario_8h.html#a59544353738dfce0bdce48409d9b3c8b">ReadKrn</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00074"></a>00074 {
<a name="l00075"></a>00075   PetscTruth flg;
<a name="l00076"></a>00076 
<a name="l00077"></a>00077   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00078"></a>00078 
<a name="l00079"></a>00079   <span class="keywordtype">int</span> rank,size;
<a name="l00080"></a>00080   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00081"></a>00081   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00082"></a>00082 
<a name="l00083"></a>00083   <span class="comment">/* TODO: maginit needs it as along as M is a shared vector during serial init. */</span>
<a name="l00084"></a>00084   ierr = MPI_Bcast(&amp;gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>,1,MPI_INT,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00085"></a>00085   PetscSynchronizedPrintf(PETSC_COMM_WORLD,
<a name="l00086"></a>00086     <span class="stringliteral">&quot;&lt;%i&gt;n_prop: %i\n&quot;</span>,
<a name="l00087"></a>00087     rank,gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>
<a name="l00088"></a>00088   );
<a name="l00089"></a>00089   PetscSynchronizedFlush(PETSC_COMM_WORLD);
<a name="l00090"></a>00090 
<a name="l00091"></a>00091   ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-size&quot;</span>,&amp;gdata-&gt;<a class="code" href="structGridData.html#a462c4e47756448bdd7578c61697deb6c">lenscale</a>,&amp;flg);CHKERRQ(ierr);
<a name="l00092"></a>00092   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00093"></a>00093     gdata-&gt;<a class="code" href="structGridData.html#a462c4e47756448bdd7578c61697deb6c">lenscale</a>=1e-9;
<a name="l00094"></a>00094     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00095"></a>00095       <span class="stringliteral">&quot;Option -size not found, using default value: %g\n&quot;</span>,
<a name="l00096"></a>00096       gdata-&gt;<a class="code" href="structGridData.html#a462c4e47756448bdd7578c61697deb6c">lenscale</a>
<a name="l00097"></a>00097     );
<a name="l00098"></a>00098   }
<a name="l00099"></a>00099 
<a name="l00100"></a>00100   PetscReal dum;
<a name="l00101"></a>00101   ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-alpha&quot;</span>,&amp;dum,&amp;flg);CHKERRQ(ierr);
<a name="l00102"></a>00102   <span class="keywordflow">if</span> (flg==PETSC_TRUE) {
<a name="l00103"></a>00103     PetscPrintf(MPI_COMM_WORLD,
<a name="l00104"></a>00104       <span class="stringliteral">&quot;Warning: option -alpha will be ignored, &quot;</span>
<a name="l00105"></a>00105       <span class="stringliteral">&quot;using parameter from *.krn file instead!\n&quot;</span>
<a name="l00106"></a>00106     );
<a name="l00107"></a>00107   }
<a name="l00108"></a>00108 
<a name="l00109"></a>00109   <span class="comment">/* SI value = internal (dimensionless) value * scaling factor */</span>
<a name="l00110"></a>00110 
<a name="l00111"></a>00111   <span class="comment">/* always scale fields and Js with 1.0 T, because the Js scaling parameter</span>
<a name="l00112"></a>00112 <span class="comment">     in allopt.txt only confused users</span>
<a name="l00113"></a>00113 <span class="comment">  */</span>
<a name="l00114"></a>00114   gdata-&gt;<a class="code" href="structGridData.html#adef301a549db3735cb025a5088ee0db6">hscale</a>=1.0;
<a name="l00115"></a>00115   gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>=<a class="code" href="griddata_8h.html#a0fa11f33bdb89b468b60f19395381cc4">MU0</a>/(gdata-&gt;<a class="code" href="structGridData.html#adef301a549db3735cb025a5088ee0db6">hscale</a>*<a class="code" href="griddata_8h.html#a8659b9de3e544ff142b153b076f30fd5">GAMMA</a>);
<a name="l00116"></a>00116   gdata-&gt;<a class="code" href="structGridData.html#af5ca6e17784da000ea45ebb5f65ebd03">escale</a>=gdata-&gt;<a class="code" href="structGridData.html#adef301a549db3735cb025a5088ee0db6">hscale</a>*gdata-&gt;<a class="code" href="structGridData.html#adef301a549db3735cb025a5088ee0db6">hscale</a>/<a class="code" href="griddata_8h.html#a0fa11f33bdb89b468b60f19395381cc4">MU0</a>;
<a name="l00117"></a>00117 
<a name="l00118"></a>00118   <span class="comment">/* ***********************************************************************</span>
<a name="l00119"></a>00119 <span class="comment">     the parameters, which have been set above need NOT be broadcast</span>
<a name="l00120"></a>00120 <span class="comment">     to all other processors any more!</span>
<a name="l00121"></a>00121 <span class="comment">  */</span>
<a name="l00122"></a>00122 
<a name="l00123"></a>00123   <span class="keywordflow">if</span> (rank) {
<a name="l00124"></a>00124     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00125"></a>00125   }
<a name="l00126"></a>00126 
<a name="l00127"></a>00127   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;\nscaling data:\n&quot;</span>);
<a name="l00128"></a>00128   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;size: %g m\n&quot;</span>,gdata-&gt;<a class="code" href="structGridData.html#a462c4e47756448bdd7578c61697deb6c">lenscale</a>);
<a name="l00129"></a>00129 
<a name="l00130"></a>00130   PetscPrintf(MPI_COMM_WORLD,
<a name="l00131"></a>00131     <span class="stringliteral">&quot;magnetization, field: hscale: %g T = %g kA/m (hardcoded)\n&quot;</span>,
<a name="l00132"></a>00132     gdata-&gt;<a class="code" href="structGridData.html#adef301a549db3735cb025a5088ee0db6">hscale</a>,
<a name="l00133"></a>00133     gdata-&gt;<a class="code" href="structGridData.html#adef301a549db3735cb025a5088ee0db6">hscale</a>/(<a class="code" href="griddata_8h.html#a0fa11f33bdb89b468b60f19395381cc4">MU0</a>*1000.0)
<a name="l00134"></a>00134   );
<a name="l00135"></a>00135   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;energy: escale: %g J/m^3 (hardcoded)\n&quot;</span>,gdata-&gt;<a class="code" href="structGridData.html#af5ca6e17784da000ea45ebb5f65ebd03">escale</a>);
<a name="l00136"></a>00136   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;time:   tscale: %g ns (hardcoded)\n&quot;</span>,gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>*1e9);
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   <span class="comment">/* TODO: read filename directly from option */</span>
<a name="l00139"></a>00139   <span class="keywordtype">char</span> str[256];
<a name="l00140"></a>00140   ierr = PetscSNPrintf(str,255,<span class="stringliteral">&quot;%s%s&quot;</span>,gdata-&gt;<a class="code" href="structGridData.html#a2fba16fa768b0451df8fd12ed00a6c6b">simname</a>,<span class="stringliteral">&quot;.krn&quot;</span>);CHKERRQ(ierr);
<a name="l00141"></a>00141 
<a name="l00142"></a>00142   FILE *fd;
<a name="l00143"></a>00143   ierr = PetscFOpen(PETSC_COMM_WORLD,str,<span class="stringliteral">&quot;r&quot;</span>,&amp;fd);CHKERRQ(ierr);
<a name="l00144"></a>00144   <span class="keywordflow">if</span> (!rank &amp;&amp; !fd) {
<a name="l00145"></a>00145     SETERRQ1(PETSC_ERR_FILE_OPEN,<span class="stringliteral">&quot;Cannot open %s\n&quot;</span>,str);
<a name="l00146"></a>00146   }
<a name="l00147"></a>00147   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Opening file %s\n&quot;</span>,str);
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 <span class="comment">/* TODO: valgrind reports lost memory:</span>
<a name="l00150"></a>00150 <span class="comment">==11675== 35,519 (14,679 direct, 20,840 indirect) bytes in 19 blocks are definitely lost in loss record 16 of 20</span>
<a name="l00151"></a>00151 <span class="comment">==11675==    at 0x4023D6E: malloc (vg_replace_malloc.c:207)</span>
<a name="l00152"></a>00152 <span class="comment">==11675==    by 0x84B9592: PetscMallocAlign(unsigned, int, char const*, char const*, char const*, void**) (in /home/scholz/work/magpar_trees/magpar/src/magpar.exe)</span>
<a name="l00153"></a>00153 <span class="comment">==11675==    by 0x80997F7: ReadKrn(GridData*) (readkrn.c:149)</span>
<a name="l00154"></a>00154 <span class="comment">==11675==    by 0x80786A7: SerInit(GridData*) (serinit.c:56)</span>
<a name="l00155"></a>00155 <span class="comment">==11675==    by 0x8063012: main (main.c:97)</span>
<a name="l00156"></a>00156 <span class="comment">*/</span>
<a name="l00157"></a>00157 
<a name="l00158"></a>00158   ierr = PetscMalloc(gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>*<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*<span class="keyword">sizeof</span>(PetscReal),&amp;gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>);CHKERRQ(ierr);
<a name="l00159"></a>00159   ierr = PetscMemzero(gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>,gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>*<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*<span class="keyword">sizeof</span>(PetscReal));CHKERRQ(ierr);
<a name="l00160"></a>00160 
<a name="l00161"></a>00161   PetscReal t_larmorf=0.0;
<a name="l00162"></a>00162 
<a name="l00163"></a>00163   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;\nscaled (dimensionless) material parameters:\n&quot;</span>);
<a name="l00164"></a>00164   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>; i++) {
<a name="l00165"></a>00165     <span class="keywordtype">char</span>      line[256], *comment, *msg;
<a name="l00166"></a>00166     PetscReal theta, phi, k1, k2, js, aexch, alpha;
<a name="l00167"></a>00167     <span class="keywordtype">int</span>       j, numchars;
<a name="l00168"></a>00168 
<a name="l00169"></a>00169     <span class="comment">/* DRL: read a WHOLE LINE to avoid silent wraparound errors */</span>
<a name="l00170"></a>00170     <a class="code" href="magpario_8h.html#a85c6fd604f4655acf9edea63969a5676">read_one_line</a>(fd, line, <span class="keyword">sizeof</span>(line), &amp;comment);
<a name="l00171"></a>00171 
<a name="l00172"></a>00172     j=sscanf(line,
<a name="l00173"></a>00173 #ifdef PETSC_USE_SINGLE
<a name="l00174"></a>00174       <span class="stringliteral">&quot;%f %f %f %f %f %f %f %n&quot;</span>,
<a name="l00175"></a>00175 #<span class="keywordflow">else</span>
<a name="l00176"></a>00176       <span class="stringliteral">&quot;%lf %lf %lf %lf %lf %lf %lf %n&quot;</span>,
<a name="l00177"></a>00177 #endif
<a name="l00178"></a>00178       &amp;theta,&amp;phi,&amp;k1,&amp;k2,&amp;js,&amp;aexch,&amp;alpha,&amp;numchars
<a name="l00179"></a>00179     );
<a name="l00180"></a>00180     <span class="keywordflow">if</span> (j!=7) {
<a name="l00181"></a>00181       SETERRQ2(PETSC_ERR_FILE_UNEXPECTED,<span class="stringliteral">&quot;Data in %s corrupt: %i!\n&quot;</span>,str,j);
<a name="l00182"></a>00182     }
<a name="l00183"></a>00183 
<a name="l00184"></a>00184     <span class="comment">/* read remainder of this line (possibly columns for cubic axes) */</span>
<a name="l00185"></a>00185     msg = &amp;line[numchars];
<a name="l00186"></a>00186 
<a name="l00187"></a>00187     assert(<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>==18+1);
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 <span class="preprocessor">#ifndef ADDONS</span>
<a name="l00190"></a>00190 <span class="preprocessor"></span>    <span class="comment">/* set saturation magnetization js=0 if js&lt;0</span>
<a name="l00191"></a>00191 <span class="comment">       unless ADDONS are compiled in</span>
<a name="l00192"></a>00192 <span class="comment">    */</span>
<a name="l00193"></a>00193     <span class="keywordflow">if</span> (js&lt;0.0) {
<a name="l00194"></a>00194       js=0.0;
<a name="l00195"></a>00195       PetscPrintf(MPI_COMM_WORLD,<span class="stringliteral">&quot;Found Js&lt;0 for material %i, resetting to Js=%g\n&quot;</span>,i+1,js);
<a name="l00196"></a>00196     }
<a name="l00197"></a>00197 <span class="preprocessor">#endif</span>
<a name="l00198"></a>00198 <span class="preprocessor"></span>
<a name="l00199"></a>00199     gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 0]=theta;
<a name="l00200"></a>00200     gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 1]=phi;
<a name="l00201"></a>00201     gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 2]=k1/gdata-&gt;<a class="code" href="structGridData.html#af5ca6e17784da000ea45ebb5f65ebd03">escale</a>;
<a name="l00202"></a>00202     gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 3]=k2/gdata-&gt;<a class="code" href="structGridData.html#af5ca6e17784da000ea45ebb5f65ebd03">escale</a>;
<a name="l00203"></a>00203     gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 4]=js/gdata-&gt;<a class="code" href="structGridData.html#adef301a549db3735cb025a5088ee0db6">hscale</a>;
<a name="l00204"></a>00204     gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 5]=aexch/(gdata-&gt;<a class="code" href="structGridData.html#af5ca6e17784da000ea45ebb5f65ebd03">escale</a>*gdata-&gt;<a class="code" href="structGridData.html#a462c4e47756448bdd7578c61697deb6c">lenscale</a>*gdata-&gt;<a class="code" href="structGridData.html#a462c4e47756448bdd7578c61697deb6c">lenscale</a>);
<a name="l00205"></a>00205     gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 9]=alpha;
<a name="l00206"></a>00206     <span class="keywordflow">if</span> (js == 0.0) {
<a name="l00207"></a>00207       alpha=999;
<a name="l00208"></a>00208       PetscPrintf(MPI_COMM_WORLD,<span class="stringliteral">&quot;Found Js==0 for material %i, locking magnetization with alpha=%g\n&quot;</span>,i+1,alpha);
<a name="l00209"></a>00209     }
<a name="l00210"></a>00210 
<a name="l00211"></a>00211     PetscPrintf(MPI_COMM_WORLD,<span class="stringliteral">&quot;----- property: %i -----\n&quot;</span>,i);
<a name="l00212"></a>00212     <span class="keywordflow">if</span> (comment)
<a name="l00213"></a>00213       PetscPrintf(MPI_COMM_WORLD, <span class="stringliteral">&quot;comment:%s\n&quot;</span>, comment);
<a name="l00214"></a>00214 
<a name="l00215"></a>00215     <span class="comment">/* see if psi is there - then we have cubic anisotropy! */</span>
<a name="l00216"></a>00216     PetscReal psi;
<a name="l00217"></a>00217     psi=PETSC_MIN;
<a name="l00218"></a>00218 <span class="preprocessor">#ifdef PETSC_USE_SINGLE</span>
<a name="l00219"></a>00219 <span class="preprocessor"></span>    j=sscanf(msg,<span class="stringliteral">&quot;%f %n&quot;</span>,&amp;psi,&amp;numchars);
<a name="l00220"></a>00220 <span class="preprocessor">#else</span>
<a name="l00221"></a>00221 <span class="preprocessor"></span>    j=sscanf(msg,<span class="stringliteral">&quot;%lf %n&quot;</span>,&amp;psi,&amp;numchars);
<a name="l00222"></a>00222 <span class="preprocessor">#endif</span>
<a name="l00223"></a>00223 <span class="preprocessor"></span>    <span class="keywordflow">if</span> (j==1) {
<a name="l00224"></a>00224       msg = &amp;msg[numchars];
<a name="l00225"></a>00225       <span class="comment">/* specify the cubic anistropy axis via Euler angles,</span>
<a name="l00226"></a>00226 <span class="comment">         using the &quot;x-convention&quot;</span>
<a name="l00227"></a>00227 <span class="comment">         (let&#39;s pretend to be physicists- i.e.</span>
<a name="l00228"></a>00228 <span class="comment">         Goldstein&#39;s &quot;Classical Mechanics&quot;,</span>
<a name="l00229"></a>00229 <span class="comment">         2nd ed. p143-148, Addison-Wesley (1980))</span>
<a name="l00230"></a>00230 <span class="comment">         e.g. http://mathworld.wolfram.com/EulerAngles.html</span>
<a name="l00231"></a>00231 <span class="comment">         first rotate about z-axis by phi,</span>
<a name="l00232"></a>00232 <span class="comment">         then rotate about new x-axis by theta,</span>
<a name="l00233"></a>00233 <span class="comment">         then rotate about new z-axis by psi</span>
<a name="l00234"></a>00234 <span class="comment">      */</span>
<a name="l00235"></a>00235       gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+16]=1;  <span class="comment">/* cubic! */</span>
<a name="l00236"></a>00236       gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 6]= cos(psi)*cos(phi)-cos(theta)*sin(phi)*sin(psi);  <span class="comment">/* &#39;x-axis&#39; for cubic, x component */</span>
<a name="l00237"></a>00237       gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 7]= cos(psi)*sin(phi)+cos(theta)*cos(phi)*sin(psi);   <span class="comment">/* y component */</span>
<a name="l00238"></a>00238       gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 8]= sin(psi)*sin(theta); <span class="comment">/* z component */</span>
<a name="l00239"></a>00239       gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+10]=-sin(psi)*cos(phi)-cos(theta)*sin(phi)*cos(psi);  <span class="comment">/* &#39;y-axis&#39; for cubic */</span>
<a name="l00240"></a>00240       gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+11]=-sin(psi)*sin(phi)+cos(theta)*cos(phi)*cos(psi);
<a name="l00241"></a>00241       gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+12]= cos(psi)*sin(theta);
<a name="l00242"></a>00242       gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+13]= sin(phi)*sin(theta);  <span class="comment">/* &#39;z-axis&#39; for cubic */</span>
<a name="l00243"></a>00243       gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+14]=-cos(phi)*sin(theta);
<a name="l00244"></a>00244       gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+15]= cos(theta);
<a name="l00245"></a>00245 
<a name="l00246"></a>00246       PetscPrintf(MPI_COMM_WORLD,
<a name="l00247"></a>00247         <span class="stringliteral">&quot;Euler angles: \n&quot;</span>
<a name="l00248"></a>00248         <span class="stringliteral">&quot; theta:  %g rad    phi: %g rad    psi :%g rad\n&quot;</span>
<a name="l00249"></a>00249         <span class="stringliteral">&quot; theta:  %g deg    phi: %g deg    psi :%g deg\n&quot;</span>
<a name="l00250"></a>00250         <span class="stringliteral">&quot;Cubic anisotropy axes: \n&quot;</span>
<a name="l00251"></a>00251         <span class="stringliteral">&quot; a-axis: (%g, %g, %g)\n&quot;</span>
<a name="l00252"></a>00252         <span class="stringliteral">&quot; b-axis: (%g, %g, %g)\n&quot;</span>
<a name="l00253"></a>00253         <span class="stringliteral">&quot; c-axis: (%g, %g, %g)\n&quot;</span>
<a name="l00254"></a>00254         <span class="stringliteral">&quot;K1:     %g  (cubic)\n&quot;</span>
<a name="l00255"></a>00255         <span class="stringliteral">&quot;K2:     %g  (cubic)\n&quot;</span>,
<a name="l00256"></a>00256         gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 0],
<a name="l00257"></a>00257         gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 1],
<a name="l00258"></a>00258         psi,
<a name="l00259"></a>00259         gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 0]*180.0/PETSC_PI,
<a name="l00260"></a>00260         gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 1]*180.0/PETSC_PI,
<a name="l00261"></a>00261         psi*180.0/PETSC_PI,
<a name="l00262"></a>00262         gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 6],
<a name="l00263"></a>00263         gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 7],
<a name="l00264"></a>00264         gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 8],
<a name="l00265"></a>00265         gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+10],
<a name="l00266"></a>00266         gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+11],
<a name="l00267"></a>00267         gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+12],
<a name="l00268"></a>00268         gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+13],
<a name="l00269"></a>00269         gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+14],
<a name="l00270"></a>00270         gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+15],
<a name="l00271"></a>00271         gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 2],
<a name="l00272"></a>00272         gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 3]
<a name="l00273"></a>00273       );
<a name="l00274"></a>00274     }
<a name="l00275"></a>00275     <span class="keywordflow">else</span> {
<a name="l00276"></a>00276       <span class="keywordtype">char</span> str2[256];
<a name="l00277"></a>00277       j=sscanf(msg,<span class="stringliteral">&quot;%s %n&quot;</span>,&amp;str2[0],&amp;numchars);
<a name="l00278"></a>00278       msg = &amp;msg[numchars];
<a name="l00279"></a>00279 
<a name="l00280"></a>00280       clearerr(fd);    <span class="comment">/* clear EOF and error indicators for fd */</span>
<a name="l00281"></a>00281       gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+16]=0;       <span class="comment">/* uniaxial */</span>
<a name="l00282"></a>00282       gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 6]=sin(theta)*cos(phi);
<a name="l00283"></a>00283       gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 7]=sin(theta)*sin(phi);
<a name="l00284"></a>00284       gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 8]=cos(theta);
<a name="l00285"></a>00285 
<a name="l00286"></a>00286       PetscPrintf(MPI_COMM_WORLD,
<a name="l00287"></a>00287         <span class="stringliteral">&quot;theta:  %g rad = %g deg    phi: %g rad = %g deg\n&quot;</span>
<a name="l00288"></a>00288         <span class="stringliteral">&quot;c-axis: (%g, %g, %g)\n&quot;</span>
<a name="l00289"></a>00289         <span class="stringliteral">&quot;K1:     %g  (uniaxial)\n&quot;</span>
<a name="l00290"></a>00290         <span class="stringliteral">&quot;K2:     %g  (uniaxial)\n&quot;</span>,
<a name="l00291"></a>00291         gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 0],
<a name="l00292"></a>00292         gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 0]*180.0/PETSC_PI,
<a name="l00293"></a>00293         gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 1],
<a name="l00294"></a>00294         gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 1]*180.0/PETSC_PI,
<a name="l00295"></a>00295         gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 6],
<a name="l00296"></a>00296         gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 7],
<a name="l00297"></a>00297         gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 8],
<a name="l00298"></a>00298         gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 2],
<a name="l00299"></a>00299         gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 3]
<a name="l00300"></a>00300       );
<a name="l00301"></a>00301     }
<a name="l00302"></a>00302 
<a name="l00303"></a>00303     PetscReal mu,a;
<a name="l00304"></a>00304 <span class="preprocessor">#ifdef PETSC_USE_SINGLE</span>
<a name="l00305"></a>00305 <span class="preprocessor"></span>    j=sscanf(msg,<span class="stringliteral">&quot;%f %f&quot;</span>,&amp;mu,&amp;a);
<a name="l00306"></a>00306 <span class="preprocessor">#else</span>
<a name="l00307"></a>00307 <span class="preprocessor"></span>    j=sscanf(msg,<span class="stringliteral">&quot;%lf %lf&quot;</span>,&amp;mu,&amp;a);
<a name="l00308"></a>00308 <span class="preprocessor">#endif</span>
<a name="l00309"></a>00309 <span class="preprocessor"></span>    <span class="keywordflow">if</span> (j==2) {
<a name="l00310"></a>00310       gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+17]=mu; <span class="comment">/* permeability */</span>
<a name="l00311"></a>00311       gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+18]=a;  <span class="comment">/* a parameter for knee */</span>
<a name="l00312"></a>00312       PetscPrintf(MPI_COMM_WORLD,
<a name="l00313"></a>00313         <span class="stringliteral">&quot;mu:     %g\n&quot;</span>
<a name="l00314"></a>00314         <span class="stringliteral">&quot;a:      %g\n&quot;</span>,
<a name="l00315"></a>00315         gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+17],
<a name="l00316"></a>00316         gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+18]
<a name="l00317"></a>00317       );
<a name="l00318"></a>00318       <span class="keywordflow">if</span> ((gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 4]&gt;0.0  &amp;&amp; gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+17]==1.0) ||
<a name="l00319"></a>00319           (gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 4]==0.0 &amp;&amp; gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+17]!=1.0) ||
<a name="l00320"></a>00320           (gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+17]&lt;0.0)
<a name="l00321"></a>00321       ) {
<a name="l00322"></a>00322         SETERRQ2(PETSC_ERR_ARG_INCOMP,
<a name="l00323"></a>00323           <span class="stringliteral">&quot;Warning: Incorrect material with Ms=%g and mu=%g\n&quot;</span>,
<a name="l00324"></a>00324           gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 4],
<a name="l00325"></a>00325           gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+17]
<a name="l00326"></a>00326         );
<a name="l00327"></a>00327       }
<a name="l00328"></a>00328     }
<a name="l00329"></a>00329 
<a name="l00330"></a>00330     PetscPrintf(MPI_COMM_WORLD,
<a name="l00331"></a>00331       <span class="stringliteral">&quot;Js:     %g\n&quot;</span>
<a name="l00332"></a>00332       <span class="stringliteral">&quot;A:      %g\n&quot;</span>
<a name="l00333"></a>00333       <span class="stringliteral">&quot;alpha:  %g\n&quot;</span>
<a name="l00334"></a>00334       <span class="stringliteral">&quot;H_ani   = 2*K1/Js: %g A/m = %g T\n&quot;</span>
<a name="l00335"></a>00335       <span class="stringliteral">&quot;l_exch1 = sqrt(2*mu0*A/Js^2):      %g nm\n&quot;</span>,
<a name="l00336"></a>00336       gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 4],
<a name="l00337"></a>00337       gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 5],
<a name="l00338"></a>00338       gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 9],
<a name="l00339"></a>00339       2.0*k1/js,
<a name="l00340"></a>00340       2.0*<a class="code" href="griddata_8h.html#a0fa11f33bdb89b468b60f19395381cc4">MU0</a>*k1/js,
<a name="l00341"></a>00341       sqrt(2.0*aexch*<a class="code" href="griddata_8h.html#a0fa11f33bdb89b468b60f19395381cc4">MU0</a>/(js*js))*1e9
<a name="l00342"></a>00342     );
<a name="l00343"></a>00343     <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 9]&lt;0) {
<a name="l00344"></a>00344       PetscPrintf(MPI_COMM_WORLD,
<a name="l00345"></a>00345         <span class="stringliteral">&quot;Warning: alpha=%g &lt; 0! Using modified (large) alpha at t&lt;0!\n&quot;</span>,
<a name="l00346"></a>00346         gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 9]
<a name="l00347"></a>00347       );
<a name="l00348"></a>00348     }
<a name="l00349"></a>00349     <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*i+ 4]==0.0) {
<a name="l00350"></a>00350       PetscPrintf(MPI_COMM_WORLD,<span class="stringliteral">&quot;Found material with Js==0!\n&quot;</span>);
<a name="l00351"></a>00351     }
<a name="l00352"></a>00352     <span class="comment">/* l_exch1 and l_exch2, both are called &quot;exchange length&quot;!</span>
<a name="l00353"></a>00353 <span class="comment">       cf. Hubert, Schaefer, Magnetic Domains, p. 153</span>
<a name="l00354"></a>00354 <span class="comment">    */</span>
<a name="l00355"></a>00355 
<a name="l00356"></a>00356     <span class="keywordflow">if</span> (PetscAbsReal(k1)&gt;<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>) {
<a name="l00357"></a>00357       PetscPrintf(MPI_COMM_WORLD,
<a name="l00358"></a>00358         <span class="stringliteral">&quot;l_exch2 = sqrt(abs(A/K1)):         %g nm\n&quot;</span>,
<a name="l00359"></a>00359         sqrt(PetscAbsReal(aexch/k1))*1e9
<a name="l00360"></a>00360       );
<a name="l00361"></a>00361 
<a name="l00362"></a>00362       PetscPrintf(MPI_COMM_WORLD,
<a name="l00363"></a>00363         <span class="stringliteral">&quot;l_Bloch = Pi*sqrt(abs(A/K1)):      %g nm\n&quot;</span>,
<a name="l00364"></a>00364         PETSC_PI*sqrt(PetscAbsReal(aexch/k1))*1e9
<a name="l00365"></a>00365       );
<a name="l00366"></a>00366     }
<a name="l00367"></a>00367 
<a name="l00368"></a>00368     PetscPrintf(MPI_COMM_WORLD,
<a name="l00369"></a>00369       <span class="stringliteral">&quot;E_Bloch = 4.0*sqrt(abs(A*K1)):     %g J/m^2\n&quot;</span>,
<a name="l00370"></a>00370       4.0*sqrt(PetscAbsReal(aexch*k1))
<a name="l00371"></a>00371     );
<a name="l00372"></a>00372 
<a name="l00373"></a>00373     <span class="comment">/* larmor frequency in anisotropy field */</span>
<a name="l00374"></a>00374     PetscReal t_larmorf2;
<a name="l00375"></a>00375     <span class="keywordflow">if</span> (k1 &gt; <a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>) {
<a name="l00376"></a>00376       t_larmorf2=<a class="code" href="griddata_8h.html#a8659b9de3e544ff142b153b076f30fd5">GAMMA</a>*2.0*k1/js;
<a name="l00377"></a>00377       PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;f_Larmor_ani: %g GHz -&gt; T=1/f=%g ns\n&quot;</span>,t_larmorf2/(2.0*PETSC_PI*1e9),1.0/(t_larmorf2/(2.0*PETSC_PI*1e9)));
<a name="l00378"></a>00378       t_larmorf=PetscMax(t_larmorf,t_larmorf2);
<a name="l00379"></a>00379     }
<a name="l00380"></a>00380 
<a name="l00381"></a>00381     <span class="comment">/* larmor frequency in demag field</span>
<a name="l00382"></a>00382 <span class="comment">       (assumes demag factor N=1, e.g. thin film)</span>
<a name="l00383"></a>00383 <span class="comment">    */</span>
<a name="l00384"></a>00384     t_larmorf2=<a class="code" href="griddata_8h.html#a8659b9de3e544ff142b153b076f30fd5">GAMMA</a>*js/<a class="code" href="griddata_8h.html#a0fa11f33bdb89b468b60f19395381cc4">MU0</a>;
<a name="l00385"></a>00385     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;f_Larmor_dem: %g GHz -&gt; T=1/f=%g ns\n&quot;</span>,t_larmorf2/(2.0*PETSC_PI*1e9),1.0/(t_larmorf2/(2.0*PETSC_PI*1e9)));
<a name="l00386"></a>00386     t_larmorf=PetscMax(t_larmorf,t_larmorf2);
<a name="l00387"></a>00387   }
<a name="l00388"></a>00388 
<a name="l00389"></a>00389   ierr = PetscFClose(PETSC_COMM_WORLD,fd);CHKERRQ(ierr);
<a name="l00390"></a>00390 
<a name="l00391"></a>00391   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00392"></a>00392 }
<a name="l00393"></a>00393 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

